Unit AMM4C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AMM4C(var A :Array of Complex; N :Integer; M :Integer;
                var B :Array of Complex; MLB :Integer; MUB :Integer;
                var C :Array of Complex);

implementation

procedure AMM4C(var A :Array of Complex; N :Integer; M :Integer;
                var B :Array of Complex; MLB :Integer; MUB :Integer;
                var C :Array of Complex);
var
NLCP1,NC,NLA1,I,LCA,JCB1,IRB1,ICNT,J,IRB,JCB,LC,L,K,NCA1 :Integer;
SUM :Complex;
label
_5,_10,_15,_20,_25;
begin

NLCP1  := MLB + 1;
NC  := NLCP1 + MUB;
NCA1  := M - MLB;
for I:=1 to N do
 begin
  LCA  := 1;
  JCB1  := NLCP1;
  IRB1  := 1;
  ICNT  := 0;
  for J:=1 to M do
   begin
    IRB  := IRB1;
    JCB  := JCB1;
    LC  := LCA;
    SUM  := Cmplx(0.0,0.0);
    L  := Min0(JCB,NC);
    if ( J  <=  NCA1 ) 
     then goto _5;
    ICNT  := ICNT+1;
    L  := L - ICNT;
_5:
    for K:=1 to L do
     begin
      SUM  := AddC(SUM,MulC(A[(I-1)+(LC-1)*N],B[(IRB-1)+(JCB-1)*M]));
      JCB  := JCB -1;
      IRB  := IRB + 1;
      LC  := LC + 1;
_10:
     end;
    C[(I-1)+(J-1)*N] := SUM;
    if ( JCB1  <  NC ) 
     then goto _15;
    IRB1  := IRB1 + 1;
    LCA  := LCA + 1;
    goto _20;
_15:
    JCB1  := JCB1 + 1;
_20:
   end;
_25:
 end;
end;

end.
